// SimpleGUI demo, demonstrating most SimpleGUI controls.

#include "MicroGlut.h"
#include "SimpleGUIMicro.h"
#include <string.h>
//uses framework Cocoa
//uses framework OpenGL

float testr, testg, testb, testf = 5;
int testboolean;
int testradio;
char testString[1024] = "Type here";

float myvec3[3];

void HitButton()
{
	testr = 0;
	testg = 0;
	testb = 0;
}

void SetToRed()
{
	testr = 1;
	testg = 0;
	testb = 0;
}

void SetToGreen()
{
	testr = 0;
	testg = 1;
	testb = 0;
}

void SetToBlue()
{
	testr = 0;
	testg = 0;
	testb = 1;
}


void init()
{
	sgCreateStaticString(60, 40, "This is a demo of SimpleGUI Micro");
	
	// A slider and a float display
	sgCreateStaticString(40, 60, "Slider and float display");
	sgCreateSlider(40, 70, 100, &testf, 5, 10);
	sgCreateDisplayFloat(40, 80, "Value: ", &testf);

	sgCreateStaticString(40, 100, "Checkbox controlling a boolean variable");
	sgCreateCheckBox(40, 110, "Check me", &testboolean);
	sgCreateDisplayInt(160, 110, "Result: ", &testboolean);

	sgCreateStaticString(40, 130, "Slider color group");
	sgCreateSliderColorGroup(20, 140, 100, &testr, &testg, &testb);

	// Radio group: Connect to same variable!
	sgCreateStaticString(240, 140, "Radio buttons:");
	sgCreateRadio(240, 160, "One", &testradio, 1);
	sgCreateRadio(240, 170, "Two", &testradio, 2);
	sgCreateRadio(240, 180, "Three", &testradio, 3);
	sgCreateDisplayInt(240, 200, "Result: ", &testradio);

	sgCreateStaticString(40, 220, "Single line editor:");
	sgCreateDynamicString(40, 230, testString);

//	"Military theme"
//	sgSetSliderFillColor(0.3, 0.5, 1.0);
//	sgSetFrameColor(0.2, 0.0, 0.5);
//	sgSetBackgroundBorder(15);
//	sgSetBackgroundColor(0.7, 1.0, 0.7, 0.3);
//	sgSetTextColor(0.8, 1.0, 1.0);
	
	sgCreateSmallColorPalette(40, 170, &testr, &testg, &testb);
	sgCreateStaticString(120, 180, "Palette");
	sgCreateButton(120, 190, "RESET", HitButton);

	sgCreateMenu(120, 200, "Colors menu");
	sgCreateMenuItem("Set to red", SetToRed);
	sgCreateMenuItem("Set to green", SetToGreen);
	sgCreateMenuItem("Set to blue", SetToBlue);

	sgSetPosition(70, 20);
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	sgDraw();
	glutSwapBuffers();
}

void keyboard(unsigned char key, int x, int y)
{
	// The "single line editor", edit the string
	int l = strlen(testString);
	if ((key == 127) && (l > 0))
	{
		testString[l-1] = 0;
	}
	else
	if (key >= 32 && l < 128)
	{
		testString[l] = key;
		testString[l+1] = 0;
	}
	
	glutPostRedisplay();
}

void mouse(int button, int state, int x, int y)
{
	if (button == 0) sgMouse(state, x, y);
	glutPostRedisplay();
}

void drag(int x, int y)
{
	sgMouseDrag(x, y);
	glutPostRedisplay();
}

int main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowPosition(40,50);
	glutInitWindowSize(500,300);
	glutInitContextVersion(3, 2);
	glutCreateWindow("SimpleGUI demo, Micro version");
	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);
	glutMotionFunc(drag);
	
	init();

	glutMainLoop();
}
